public inbox for git-commits@fedoraproject.org
help / color / mirror / Atom feed
From: Milos Malik <mmalik@redhat.com>
To: git-commits@fedoraproject.org
Subject: [tests/selinux] pr775-checkpolicy-revdeps: add new test which covers the stacd and stafd services
Date: Fri, 11 Sep 2026 13:20:21 GMT	[thread overview]
Message-ID: <178913282172.1.11020221247004051296.tests-selinux-202b220c73d0@fedoraproject.org> (raw)

            A new commit has been pushed.

            Repo   : tests/selinux
            Branch : pr775-checkpolicy-revdeps
            Commit : 202b220c73d0c1d183440cf4864ce63e27f1c5e0
            Author : Milos Malik <mmalik@redhat.com>
            Date   : 2022-12-07T08:29:32+00:00
            Stats  : +238/-0 in 4 file(s)
            URL    : https://src.fedoraproject.org/tests/selinux/c/202b220c73d0c1d183440cf4864ce63e27f1c5e0?branch=pr775-checkpolicy-revdeps

            Log:
            add new test which covers the stacd and stafd services

SELinux policy now contains a new policy module which confines the
stacd and stafd services, which belong to the nvme-stas package.
This TC covers basic scenarios of running the services in default
configuration. The TC also looks for appropriate policy rules and
file context patterns.

The TC covers BZ#2111414.

---
diff --git a/selinux-policy/nvme-stas-and-similar/Makefile b/selinux-policy/nvme-stas-and-similar/Makefile
new file mode 100644
index 0000000..e528da4
--- /dev/null
+++ b/selinux-policy/nvme-stas-and-similar/Makefile
@@ -0,0 +1,69 @@
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Makefile of /CoreOS/selinux-policy/Regression/nvme-stas-and-similar
+#   Description: SELinux interferes with NVME sta* services
+#   Author: Milos Malik <mmalik@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Copyright (c) 2022 Red Hat, Inc. All rights reserved.
+#
+#   This copyrighted material is made available to anyone wishing
+#   to use, modify, copy, or redistribute it subject to the terms
+#   and conditions of the GNU General Public License version 2.
+#
+#   This program is distributed in the hope that it will be
+#   useful, but WITHOUT ANY WARRANTY; without even the implied
+#   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#   PURPOSE. See the GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public
+#   License along with this program; if not, write to the Free
+#   Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+#   Boston, MA 02110-1301, USA.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+export TEST=/CoreOS/selinux-policy/Regression/nvme-stas-and-similar
+export TESTVERSION=1.0
+
+BUILT_FILES=
+
+FILES=$(METADATA) runtest.sh Makefile PURPOSE
+
+.PHONY: all install download clean
+
+run: $(FILES) build
+	./runtest.sh
+
+build: $(BUILT_FILES)
+	chmod a+x runtest.sh
+	chcon -t bin_t runtest.sh
+
+clean:
+	rm -f *~ $(BUILT_FILES)
+
+include /usr/share/rhts/lib/rhts-make.include
+
+$(METADATA): Makefile
+	@echo "Owner:           Milos Malik <mmalik@redhat.com>" > $(METADATA)
+	@echo "Name:            $(TEST)" >> $(METADATA)
+	@echo "TestVersion:     $(TESTVERSION)" >> $(METADATA)
+	@echo "Path:            $(TEST_DIR)" >> $(METADATA)
+	@echo "Description:     SELinux interferes with NVME sta* services" >> $(METADATA)
+	@echo "Type:            Regression" >> $(METADATA)
+	@echo "TestTime:        10m" >> $(METADATA)
+	@echo "RunFor:          nvme-stas" >> $(METADATA)
+	@echo "RunFor:          selinux-policy" >> $(METADATA)
+	@echo "Requires:        avahi audit libselinux libselinux-utils policycoreutils selinux-policy selinux-policy-targeted setools-console /usr/sbin/service nvme-stas" >> $(METADATA)
+	@echo "RhtsRequires:    library(selinux-policy/common)" >> $(METADATA)
+	@echo "Environment:     AVC_ERROR=+no_avc_check" >> $(METADATA)
+	@echo "Priority:        Normal" >> $(METADATA)
+	@echo "License:         GPLv2" >> $(METADATA)
+	@echo "Confidential:    no" >> $(METADATA)
+	@echo "Destructive:     no" >> $(METADATA)
+	@echo "Releases:        -RHEL4 -RHEL5 -RHEL6 -RHEL7 -RHEL8" >> $(METADATA)
+	@echo "Bug:             2111414" >> $(METADATA) # RHEL-9
+
+	rhts-lint $(METADATA)
+

diff --git a/selinux-policy/nvme-stas-and-similar/PURPOSE b/selinux-policy/nvme-stas-and-similar/PURPOSE
new file mode 100644
index 0000000..5f9b111
--- /dev/null
+++ b/selinux-policy/nvme-stas-and-similar/PURPOSE
@@ -0,0 +1,5 @@
+PURPOSE of /CoreOS/selinux-policy/Regression/nvme-stas-and-similar
+Author: Milos Malik <mmalik@redhat.com>
+
+SELinux interferes with NVME sta* services
+

diff --git a/selinux-policy/nvme-stas-and-similar/main.fmf b/selinux-policy/nvme-stas-and-similar/main.fmf
new file mode 100644
index 0000000..0e83395
--- /dev/null
+++ b/selinux-policy/nvme-stas-and-similar/main.fmf
@@ -0,0 +1,41 @@
+summary: SELinux interferes with NVME sta* services
+description: |+
+    SELinux interferes with NVME sta* services
+
+contact: Milos Malik <mmalik@redhat.com>
+component:
+  - nvme-stas
+  - selinux-policy
+require:
+  - library(selinux-policy/common)
+recommend:
+  - avahi
+  - audit
+  - libselinux
+  - libselinux-utils
+  - policycoreutils
+  - selinux-policy
+  - selinux-policy-targeted
+  - setools-console
+  - /usr/sbin/service
+  - nvme-stas
+environment:
+    AVC_ERROR: +no_avc_check
+duration: 10m
+enabled: true
+tag:
+  - NoRHEL4
+  - NoRHEL5
+  - NoRHEL6
+  - NoRHEL7
+  - NoRHEL8
+  - targeted
+link:
+  - verifies: https://bugzilla.redhat.com/show_bug.cgi?id=2111414
+adjust:
+  - enabled: false
+    when: distro == rhel-4, rhel-5, rhel-6, rhel-7, rhel-8
+    because: the nvme-stas package is not available there
+extra-summary: /CoreOS/selinux-policy/Regression/nvme-stas-and-similar
+extra-task: /CoreOS/selinux-policy/Regression/nvme-stas-and-similar
+extra-nitrate: TC#0614621

diff --git a/selinux-policy/nvme-stas-and-similar/runtest.sh b/selinux-policy/nvme-stas-and-similar/runtest.sh
new file mode 100755
index 0000000..a86991e
--- /dev/null
+++ b/selinux-policy/nvme-stas-and-similar/runtest.sh
@@ -0,0 +1,123 @@
+#!/bin/bash
+# vim: dict=/usr/share/beakerlib/dictionary.vim cpt=.,w,b,u,t,i,k
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   runtest.sh of /CoreOS/selinux-policy/Regression/nvme-stas-and-similar
+#   Description: SELinux interferes with NVME sta* services
+#   Author: Milos Malik <mmalik@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Copyright (c) 2022 Red Hat, Inc. All rights reserved.
+#
+#   This copyrighted material is made available to anyone wishing
+#   to use, modify, copy, or redistribute it subject to the terms
+#   and conditions of the GNU General Public License version 2.
+#
+#   This program is distributed in the hope that it will be
+#   useful, but WITHOUT ANY WARRANTY; without even the implied
+#   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#   PURPOSE. See the GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public
+#   License along with this program; if not, write to the Free
+#   Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+#   Boston, MA 02110-1301, USA.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+# Include Beaker environment
+. /usr/share/beakerlib/beakerlib.sh || exit 1
+
+PACKAGE="selinux-policy"
+FILE_CONTEXT="stas_exec_t"
+SERVICE_PACKAGE="nvme-stas"
+PROCESS_CONTEXT="stas_t"
+
+rlJournalStart
+    rlPhaseStartSetup
+        rlRun "rlImport 'selinux-policy/common'"
+        rlSESatisfyRequires
+        rlAssertRpm ${PACKAGE}
+        rlAssertRpm ${PACKAGE}-targeted
+        rlAssertRpm ${SERVICE_PACKAGE}
+
+        rlServiceStart avahi-daemon
+        rlServiceStop stacd stafd
+        rlFileBackup /usr/lib/systemd/system/stacd.service
+        rlFileBackup /usr/lib/systemd/system/stafd.service
+
+        rlSESetEnforce
+        rlSEStatus
+        rlSESetTimestamp
+        sleep 2
+    rlPhaseEnd
+
+    if rlSEDefined "${FILE_CONTEXT} ${PROCESS_CONTEXT}" ; then
+    rlPhaseStartTest "bz#2111414"
+        rlSEMatchPathCon "/usr/sbin/stacd" "${FILE_CONTEXT}"
+        rlSEMatchPathCon "/usr/sbin/stafd" "${FILE_CONTEXT}"
+        rlSEMatchPathCon "/dev/nvme-fabrics" "fixed_disk_device_t"
+        rlSEMatchPathCon "/run/systemd/journal/socket" "syslogd_var_run_t"
+        rlSEMatchPathCon "/run/stacd" "stas_var_run_t"
+        rlSEMatchPathCon "/run/stacd/last-known-config.pickle" "stas_var_run_t"
+        rlSEMatchPathCon "/run/stafd" "stas_var_run_t"
+        rlSEMatchPathCon "/run/stafd/last-known-config.pickle" "stas_var_run_t"
+        rlSEMatchPathCon "/run/udev/" "udev_var_run_t"
+        rlSEMatchPathCon "/run/udev/rules.d/" "udev_var_run_t"
+        rlSEMatchPathCon "/run/udev/rules.d/70-nvmf-autoconnect.rules" "udev_var_run_t"
+        rlSEMatchPathCon "/var/cache/stacd" "stas_cache_t"
+        rlSEMatchPathCon "/var/cache/stafd" "stas_cache_t"
+        SOURCE_TYPE="init_t" # systemd runs the process
+        rlSESearchRule "allow ${SOURCE_TYPE} ${FILE_CONTEXT} : file { getattr open read execute } $BOOLEANS"
+        rlSESearchRule "allow ${SOURCE_TYPE} ${PROCESS_CONTEXT} : process { transition } $BOOLEANS"
+        rlSESearchRule "type_transition ${SOURCE_TYPE} ${FILE_CONTEXT} : process ${PROCESS_CONTEXT} $BOOLEANS"
+        rlRun "semodule -lfull | grep stas"
+        rlSESearchRule "allow avahi_t stas_t : dbus { send_msg } [ ]"
+        rlSESearchRule "allow stas_t avahi_t : dbus { send_msg } [ ]"
+        rlSESearchRule "allow stas_t fixed_disk_device_t : chr_file { getattr } [ ]"
+        rlSESearchRule "allow stas_t stas_t : dbus { send_msg } [ ]"
+        rlSESearchRule "allow stas_t syslogd_var_run_t : sock_file { write } [ ]"
+        rlSESearchRule "allow stas_t system_dbusd_t : dbus { acquire_svc send_msg } [ ]"
+        rlSESearchRule "allow stas_t udev_var_run_t : dir { add_name remove_name write } [ ]"
+        rlSESearchRule "allow stas_t udev_var_run_t : file { create getattr ioctl open unlink write } [ ]"
+        rlSESearchRule "allow stas_t stas_var_run_t : file { getattr ioctl open read write } [ ]"
+    rlPhaseEnd
+    fi
+
+    rlPhaseStartTest "real scenario -- standalone service"
+        for CUR_FILE in /usr/lib/systemd/system/stacd.service \
+            /usr/lib/systemd/system/stafd.service ; do
+            if grep -q '^ExecStart=.*python' ${CUR_FILE} ; then
+                rlRun "sed -i 's|^ExecStart=.*python.* /|ExecStart=/|' ${CUR_FILE}"
+                rlRun "systemctl daemon-reload"
+                rlRun "grep '^ExecStart=' ${CUR_FILE}"
+            fi
+        done
+        if ! rlSEDefined ${PROCESS_CONTEXT} ; then
+            # for RHELs where the SELinux domain does not exist yet
+            PROCESS_CONTEXT="unconfined_service_t"
+        fi
+        rlRun "mkdir -p /etc/nvme"
+        rlRun "touch /etc/nvme/hostid"
+        rlRun "touch /etc/nvme/hostnqn"
+        rlSEService - stafd stafd ${PROCESS_CONTEXT} "start status" 1
+        rlSEService - stacd stacd ${PROCESS_CONTEXT} "start status" 1
+        rlRun "stasadm -v"
+        rlRun "stasadm hostid"
+        rlRun "stasadm hostnqn"
+        rlRun "restorecon -Rv /var /run -e /var/ARTIFACTS" 0-255
+        rlSEService - stacd stacd ${PROCESS_CONTEXT} "restart status stop status" 1
+        rlSEService - stafd stafd ${PROCESS_CONTEXT} "restart status stop status" 1
+    rlPhaseEnd
+
+    rlPhaseStartCleanup
+        sleep 2
+        rlSECheckAVC
+
+        rlFileRestore
+        rlServiceRestore stacd stafd
+    rlPhaseEnd
+rlJournalPrintText
+rlJournalEnd
+

                 reply	other threads:[~2026-09-11 13:20 UTC|newest]

Thread overview: [no followups] expand[flat|nested]  mbox.gz  Atom feed

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=178913282172.1.11020221247004051296.tests-selinux-202b220c73d0@fedoraproject.org \
    --to=mmalik@redhat.com \
    --cc=git-commits@fedoraproject.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox